#include <stdio.h>
#include <string.h>
#include <math.h>

#define SHIRINA 10000
#define VISOTA 10000

char tochki[SHIRINA*VISOTA*3];
char zagolovok[54];

struct point
{
	char blue;
	char green;
	char red;
};

struct coords
{
	double x;
	double y;
};

struct point massiv[SHIRINA][VISOTA];

struct point noll,white,redd,grey;

void pryamaya(struct coords point1,struct coords point2, struct point color);

int roundd(double a);

int isPrim(int n);

void paintPoint(struct coords g, struct point w);

int main()
{

redd.blue=255;
redd.green=255;
redd.red=0;

noll.red=0;
noll.green=0;
noll.blue=0;

grey.red=200;
grey.green=200;
grey.blue=200;

white.red=255;
white.green=255;
white.blue=255;

	int r1,r2;

for(r2=0;r2<VISOTA;++r2)
	for(r1=0;r1<SHIRINA;++r1)
	{
		massiv[r1][r2]=grey;
	}
//--------------------------------------------------------------------------------------
//
//for(r2=0;r2<200;++r2)
//	for(r1=0;r1<300;++r1)
//	massiv[r1][r2]=redd;
	struct coords l;

	int lamer;

	l.x=0;
	l.y=0;

	while( l.x < 10000)
	{
		if(isPrim(l.x))
			l.y++;

		lamer=l.x;
		if(lamer%2 == 0 )
		 paintPoint(l,noll);
		else
			paintPoint(l,redd);


		l.x++;
	}



	//coords f1,f2;
	//f1.x=30;
	//f1.y=10;
	//f2.x=850;
	//f2.y=550;

	//pryamaya(f1,f2,redd);

//--------------------------------------------------------------------------------------
	//FILE *q;
	//q=fopen("hello.txt","rb");

	////fprintf(q,"Hello, world1!");
	//int t[100];

	////for(int i=0;i<3;++i)
	//{
	//fscanf(q,"%s",t);
	//printf("%s\n",t);
	//}
	//fclose(q);


	//memset(tochki,172,SHIRINA*VISOTA*3);
	int r=0;
for(r2=0;r2<VISOTA;++r2)
	for(r1=0;r1<SHIRINA;++r1)
	{
		tochki[r]=massiv[r1][r2].red;
		tochki[r+1]=massiv[r1][r2].green;
		tochki[r+2]=massiv[r1][r2].blue;
		r+=3;
	}


	FILE *q1,*q2;
	q1=fopen("test.bmp","rb");
	q2=fopen("out.bmp","wb");

	fread(zagolovok,sizeof(char),54,q1);
	fwrite(zagolovok,sizeof(char),54,q2);
	fwrite(tochki,sizeof(char),SHIRINA*VISOTA*3,q2);

	fclose(q1);
	fclose(q2);

}

int roundd(double a)
{
	int f;
	f=(int)a;

    if(a-0.5<=a)
	{
		return f;
	}
	else
		return (f+1);
}


void pryamaya(struct coords point1,struct coords point2, struct point color)
{
	struct coords a,b;
	double c,d,e;
	a=point1;
	b=point2;

	if( point1.x < point2.x && point1.y < point2.y )
	{
		a.x-=0.5;
		a.y-=0.5;
		b.x+=0.5;
		b.y+=0.5;
	}
	if( point1.x < point2.x && point1.y > point2.y )
	{
		a.x-=0.5;
		a.y+=0.5;
		b.x+=0.5;
		b.x-=0.5;
	}
	if( point1.x > point2.x && point1.y < point2.y)
	{
		a.x-=0.5;
		a.y-=0.5;
		b.x+=0.5;
		b.y+=0.5;
	}
	if( point1.x > point2.x && point1.y > point2.y)
	{
		a.x-=0.5;
		a.y+=0.5;
		b.x+=0.5;
		b.x-=0.5;
	}
	int i=0;
	double k1,k2;
	int m1,m2;


	c=a.x - b.x;
	d=a.y - b.y;
	k1=c*c;
	k2=d*d;
	e=sqrt((double)(k1+k2));
	c/=e;
	d/=e;
	while( i < e)
	{
		b.x+=c;
		b.y+=d;
		i++;
		m1=roundd(b.x);
		m2=roundd(b.y);
		//printf("%f %f\n",k1,k2);
		massiv[m1][m2]=color;
	}


}

int isPrim(int n) {

		if(n<=1)
		return 0;

	double a;
	int i;
	i=2; a=sqrt((double)n);
	while ( i <= a)
	{
		if( n%i == 0 )
			return 0;
		i++;

	}
	return 1;
}

void paintPoint(struct coords g, struct point w)
{
	int f1=g.x;
	int f2=g.y;
	massiv[f1][f2]=w;
}

